summaryrefslogtreecommitdiffabout
Side-by-side diff
Diffstat (more/less context) (ignore whitespace changes)
-rw-r--r--delta.jscad29
1 files changed, 29 insertions, 0 deletions
diff --git a/delta.jscad b/delta.jscad
index 326d172..35a777c 100644
--- a/delta.jscad
+++ b/delta.jscad
@@ -53,193 +53,222 @@ var CONFIG = {
},
hotend: {
h: 62.4, // full assembly height
groove: { d:12, h:6 }, // grove diameter and height
ungroove: { d:16, above:3.7, below: 3+4 }
},
effector: {
h: 6,
o: 20, // offset to the rod mounts line
rods_apart: 40,
cone: { shell: 1, angle: Math.PI/6 },
rodend: {
joint_w: 7, // thickness of the joint
screw_l: 20-1, // 20 with the head
screw_d: 3
},
hotend: { margin: 2 },
hinge: {
d: 3, w: 5, margin: 2.5,
h: 1+(6+3.7)/2, // elevation + grove + top
e: 1 // elevation
},
clamp: {
shell: 4.6,
d: 3,
margin: 2.5,
split: 0.6
},
mswitch: {
size: [ 19.8, 6, 10 ],
screw: {
d: 2, h: 10/2-2,
s: 1.3, // screw shell
o: [-9.5/2,9.5/2].map(function(x) {
return -19.8/2+x;
})
},
switch_x: 2.5
},
guide: {
width: 3, height: 5+1, length: 6
},
fanholder: {
r: 30,
screw: { d: 3, m: 2.5/*margin*/ },
w: 3
}
},
nut: { h: 2.3, w: 5.5 },
color: {
extrusion: [0.8, 0.8, 0.8, 0.8],
pcb: [ 0, 0.3, 0.2, 0.8 ],
bulk: [ .9, .9, .9, .2 ],
parts: [ 0, 0.8, 0, 0.9 ],
softparts: [ 0, 0, 0.8, 0.9 ],
heatbed: [0.8, 0.8, 0.8, 0.8 ],
glass: [0.9, 0.9, 0.9, 0.7 ]
}
};
var CD = {
base: (function(){
var rv = {};
rv.circumscription_r =
CONFIG.base.sl/2/Math.cos(Math.PI/6);
rv.outer_inscription_r =
Math.sqrt(Math.pow(rv.circumscription_r,2)-
Math.pow(CONFIG.base.sl/2,2));
rv.mid_inscription_r =
rv.outer_inscription_r-CONFIG.extrusion.w/2;
rv.inner_inscription_r =
rv.outer_inscription_r-CONFIG.extrusion.w;
// TODO: properly calculate
rv.column_r = rv.circumscription_r - 48.29;
return rv;
})(),
duetholder: (function() {
var rv = {};
var s = CONFIG.base.sl;
var l = CONFIG.duet.hole_spacing.x;
var w = CONFIG.duet.hole_spacing.y;
var h = s*Math.cos(Math.PI/6);
var h1 = h*(1-l/s);
rv.distance = (h1-w)/3; // hole to side
return rv;
})()
};
console.log(CONFIG); console.log(CD);
var U = {
hypotenuse: function(a,b) {
return Math.sqrt(Math.pow(a,2)+Math.pow(b,2));
},
peek: function(x,m) {
console.log(x,m);
return x;
+ },
+ axes: function U_axes(o) {
+ if(!o) o = {};
+ var l = o.l||20, g = o.g||0.7;
+ return union([
+ CSG.roundedCylinder({start:[0,0,0],end:[l,0,0]}).setColor([1,0,0,g]),
+ CSG.roundedCylinder({start:[0,0,0],end:[0,l,0]}).setColor([0,1,0,g]),
+ CSG.roundedCylinder({start:[0,0,0],end:[0,0,l]}).setColor([0,0,1,g])
+ ]);
+ },
+ pextract: function U_pextract(a,pn) { // TODO: monkeypatch Array
+ return a.map(function(x){return x[pn]});
+ },
+ hole: function U_hole(o) {
+ var r = o.r||o.radius||(o.d/2)||(o.diameter/2);
+ var n = Math.max(Math.round(4*r),4);
+ return CSG.cylinder({
+ start: o.start, end: o.end,
+ radius: r/Math.cos(Math.PI/n),
+ resultion: n
+ });
+ },
+
+ upright: function U_upright() { return new CSG.Connector([0,0,0],[0,0,1],[1,0,0]) },
+ downright: function U_downright() { return new CSG.Connector([0,0,0],[0,0,-1],[1,0,0]) },
+ P: function U_P(x) {
+ if(!x.properties.P) return x;
+ return x.connectTo(x.properties.P,U.upright(),false,0);
}
+
};
/* {h:,w:} */
function nut(o) {
var rv = CSG.cylinder({
start:[0,0,0],end:[0,0,o.h],
radius: o.w/2/Math.cos(Math.PI/6),
resolution: 6
});
rv.properties.axis_connector = new CSG.Connector([0,0,0],[0,0,1],[0,1,0]);
return rv;
}
var E3DV6 = {
dimensions: {
big_d: 22.3,
},
heatsink: function() {
var fn = 16;
var z=0;
var unite = [ {d:16,h:3.7},{d:12,h:6},{d:16,h:3} ].map(function(x) {
return CSG.cylinder({
start: [0,0,z], end: [0,0,z-=x.h],
radius: x.d/2, resolution: fn
});
});
unite.push(CSG.cylinder({
start:[0,0,z-=1.5], end:[0,0,z-=1],
radius: 16/2, resolution: fn
}));
for(var i=0;i<11;++i) unite.push(CSG.cylinder({
start:[0,0,z-=1.5], end:[0,0,z-=1],
radius: this.dimensions.big_d/2, resolution: fn
}));
unite.push(CSG.cylinder({
start:[0,0,z], end: [0,0,-12.7],
radiusStart: 10/2, radiusEnd: 8.5/2, /* pretty arbitrary */
resolution: fn
}));
var rv = union(unite);
rv = rv.subtract([CSG.cylinder({
start:[0,0,1], end: [0,0,z-1],
radius: 4.2/2, resolution: fn
}),CSG.cylinder({
start:[0,0,1], end: [0,0,-6.7/*somewhat arbitrary*/],
radius: 8/2, resolution: fn
}),CSG.cylinder({
start:[0,0,z-1], end: [0,0,z+14.8],
radius: 6/2 /*M7*/, resolution: fn
})]);
rv.properties.pushfit_connector = new CSG.Connector([0,0,0],[0,0,-1],[1,0,0]);
rv.properties.heatbreak_connector = new CSG.Connector([0,0,z+14.8],[0,0,-1],[1,0,0]);
rv.properties.grove_connector = new CSG.Connector([0,0,-3.7-3],[0,0,1],[1,0,0]);
return rv.setColor([0.8,0.8,0.8,0.9]);
}
};
var EFFECTOR = {
/* {sd: screw diameter, l: cone length, s: screw shell, a: angle from axis} */
cone: function effector_cone(o) {
var re = o.sd/2+o.s, rs = re+o.l*Math.tan(o.a||(Math.PI/4));
var rv = CSG.cylinder({
start: [0,0,0], end: [0,0,o.l],
radiusStart: rs, radiusEnd: re,
resolution: Math.floor(rs*2*2)
}).subtract(CSG.cylinder({
start:[0,0,-1], end:[0,0,o.l+1], radius: o.sd,
//resolution: Math.floor(o.sd*2*2)
}));
rv.properties.top_connector = new CSG.Connector([0,0,o.l],[0,0,-1],[1,0,0]);
rv.properties.bottom_connector = new CSG.Connector([0,0,0],[0,0,1],[1,0,0]);
var nuthole = nut(CONFIG.nut);
rv = rv.subtract(nuthole.connectTo(
nuthole.properties.axis_connector, rv.properties.bottom_connector,
false, 0
));
return rv.intersect(CSG.cylinder({start:[0,0,0],end:[0,0,o.l],radius:6/*TODO:calculate*/}));
},
platform_bb: function platform_bb() {
var e = CONFIG.effector;
var r = U.hypotenuse(e.rods_apart/2,e.o+e.rodend.screw_d/2+e.cone.shell);
var rv = CSG.sphere({
center: [0,0,e.h/2], radius: r,
resolution: r*2*2
}).intersect(CSG.cube({
corner1: [-r,-r,0], corner2: [r,r,e.h]
}));
rv.properties.base_connector = new CSG.Connector([0,0,0],[0,0,1],[1,0,0]);
return rv;
},
effector: function effector_effector() {
var e = CONFIG.effector;
var conel = e.rodend.screw_l-e.rodend.joint_w;
var nutr = CONFIG.nut.w/2/Math.cos(Math.PI/6);
var cone = this.cone({sd:e.rodend.screw_d/2,l:conel,s:e.cone.shell,a:e.cone.angle});